clear
close all

%% cameraman
load cameraman
[M,N] = size(X);

% random mask
sampProb = 0.5;
mask = rand(M,N) < sampProb;
X0 = X.*mask;

figure
imagesc(X0)
title('input image')
colormap('gray')

p = 0.1;
Xhat = sIRLSp(X,mask,p);

figure
imagesc(Xhat)
title('completed image')
colormap('gray')

% lines through image
mask = logical(1 - toeplitz([ones(5,1); zeros(50,1); ones(5,1); zeros(50,1); ones(5,1); zeros(N-115,1)]));
X0 = X.*mask;

figure
imagesc(X0)
title('input image')
colormap('gray')

p = 0.1;
Xhat = sIRLSp(X,mask,p);

figure
imagesc(Xhat)
title('completed image')
colormap('gray')

%% mandrill
clear
close all

load mandrill
[M,N] = size(X);

% random mask
sampProb = 0.5;
mask = rand(M,N) < sampProb;
X0 = X.*mask;

figure
imagesc(X0)
title('input image')
colormap('gray')

p = 0.1;
Xhat = sIRLSp(X,mask,p);

figure
imagesc(Xhat)
title('completed image')
colormap('gray')

% lines through image
mask = logical(1 - toeplitz([ones(5,1); zeros(50,1); ones(5,1); zeros(50,1); ones(5,1); zeros(N-115,1)]));
mask = mask(1:M,1:N);
X0 = X.*mask;

figure
imagesc(X0)
title('input image')
colormap('gray')

p = 0.1;
Xhat = sIRLSp(X,mask,p);

figure
imagesc(Xhat)
title('completed image')
colormap('gray')
