function Xhat = sIRLSp(X,mask,p)

[M,N] = size(X);

% algorithm parameters
tol = 1e-8;
maxIter = 1000;
gammaMin = 1e-20;
eta = 1.1;
sn = norm(X);       % 2-norm of X

% initialize optimization variables
Xhat = zeros(size(X));
Xhat(mask) = X(mask);
gamma = 0.01*sn^2;  % suggested initialization
s = gamma^(1 - p/2);

for kk = 1:maxIter
    Xprev = Xhat;
    W = (Xhat'*Xhat + gamma*eye(N))^(p/2 - 1);
    Xhat = Xhat - s*Xhat*W;
    Xhat(mask) = X(mask);
    gamma = max(gamma/eta,gammaMin);
    s = gamma^(1 - p/2);

    % stopping condition
    err = norm(Xprev - Xhat,'fro')/norm(Xhat,'fro');
    if err < tol
        break
    end
end
