"""
LMRC demo - imageTest

ECE 510

python version: 3.7.3

Spring 2019
"""

import numpy as np
import matplotlib.pyplot as plt
import time
from numpy import zeros, ones
from numpy.random import rand
from scipy.linalg import toeplitz
from scipy.io import loadmat
from sIRLSp import sIRLSp

## cameraman
cameraman = loadmat('cameraman.mat')
X = cameraman['X']
M, N = np.shape(X)

# random mask
sampProb = 0.5
mask = rand(M, N) < sampProb
X0 = X * mask

fig1 = plt.figure(figsize=(8,8))
plt.imshow(X0,cmap='gray')
plt.title('Input image')
plt.show()

p = 0.1

Xhat = sIRLSp(X, mask, p)

fig2 = plt.figure(figsize=(8,8))
plt.imshow(Xhat, cmap='gray')
plt.title('Completed image')
plt.show()

# lines through image
mask_col = np.vstack([ones([5,1]), zeros([50, 1]), ones([5,1]), zeros([50, 1]), ones([5,1]), zeros([N-115, 1])])
mask = (1 - toeplitz(mask_col)).astype(dtype=bool)
X0 = X * mask

fig3 = plt.figure(figsize=(8,8))
plt.imshow(X0, cmap='gray')
plt.title('Input image')
plt.show()

p = 0.1
Xhat = sIRLSp(X, mask, p)

fig4 = plt.figure(figsize=(8,8))
plt.imshow(Xhat, cmap='gray')
plt.title('Completed image')
plt.show()


## mandrill
mindrill = loadmat('mandrill.mat')
X = mindrill['X']
M, N = np.shape(X)

# random mask
sampProb = 0.5
mask = rand(M, N) < sampProb
X0 = X * mask

fig5 = plt.figure(figsize=(8,8))
plt.imshow(X0,cmap='gray')
plt.title('Input image')
plt.show()

p = 0.1
Xhat = sIRLSp(X, mask, p)

fig6 = plt.figure(figsize=(8,8))
plt.imshow(Xhat, cmap='gray')
plt.title('Completed image')
plt.show()

# lines through image
mask_col = np.vstack([ones([5,1]), zeros([50, 1]), ones([5,1]), zeros([50, 1]), ones([5,1]), zeros([N-115, 1])])
mask = (1 - toeplitz(mask_col)).astype(dtype=bool)
mask = mask[:M, :N]
X0 = X * mask

fig7 = plt.figure(figsize=(8,8))
plt.imshow(X0, cmap='gray')
plt.title('Input image')
plt.show()

p = 0.1
Xhat = sIRLSp(X, mask, p)

fig8 = plt.figure(figsize=(8,8))
plt.imshow(Xhat, cmap='gray')
plt.title('Completed image')
plt.show()
